=== debian/changelog ===
gmt (5.1.2+dfsg1-2build2) wily; urgency=medium

  * No-change rebuild for netcdf soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 26 Sep 2015 15:49:39 +0000

gmt (5.1.2+dfsg1-2) unstable; urgency=medium

  * Override dh_auto_configure to use custom CMake options.
  * Drop changes for HDF5 MPI, netcdf now built with serial flavor.
  * Add patch to fix _netcdf_dashl regex in FindNETCDF.
  * Don't build PDF documentation, latex build is prone to failure.
  * Add patches for various typos.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 24 Aug 2015 18:43:16 +0200

gmt (5.1.2+dfsg1-2~exp1) experimental; urgency=medium

  * Add patch to find the HDF5 library required for NetCDF in experimental.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 29 Jul 2015 22:30:36 +0200

gmt (5.1.2+dfsg1-1) unstable; urgency=medium

  * Add patch rename psl library to gmt-psl to resolve conflict with
    libpsl.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 23 Jul 2015 00:49:03 +0200

gmt (5.1.2+dfsg1-1~exp8) experimental; urgency=medium

  * Drop Conflicts on turnin-ng & pslib-dev,
    gmt man pages use 'gmt' suffix now.
  * Add Breaks/Replaces on old gmt-manpages to gmt-common.
    (closes: #790524)
  * Drop obsolete README.Debian file.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 10 Jul 2015 16:33:55 +0200

gmt (5.1.2+dfsg1-1~exp7) experimental; urgency=medium

  * Add patch to append 'gmt' to the man page sections.
  * Move `gzip -n` man page compression from rules to patch.
  * Don't use cmake continue() command in disable-examples.patch,
    requires CMake >= 3.2.
  * Drop libgmt-dev.links, usr/lib/gmt is no longer used.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 09 Jul 2015 22:39:30 +0200

gmt (5.1.2+dfsg1-1~exp6) experimental; urgency=medium

  * Add Breaks/Replaces on libgenome-perl versions preceding the gmt rename.
    (closes: #790524)

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 09 Jul 2015 08:13:17 +0200

gmt (5.1.2+dfsg1-1~exp5) experimental; urgency=medium

  * Add versioned Breaks/Replaces on gmt to gmt-common.
    (closes: #790521)
  * Add Conflicts on turnin-ng & pslib-dev to gmt-common,
    and libpsl-dev to libgmt-dev.
  * Add references to upstream metadata.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 03 Jul 2015 19:30:54 +0200

gmt (5.1.2+dfsg1-1~exp4) experimental; urgency=medium

  * Add patch to fix build on mips*.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 27 Jun 2015 15:53:32 +0200

gmt (5.1.2+dfsg1-1~exp3) experimental; urgency=medium

  * Only recompress man pages if they exist.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 26 Jun 2015 21:07:10 +0200

gmt (5.1.2+dfsg1-1~exp2) experimental; urgency=medium

  * Fix removal of empty directory.
  * Add patch to fix build on kFreeBSD.
  * Add upstream metadata.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 26 Jun 2015 19:36:59 +0200

gmt (5.1.2+dfsg1-1~exp1) experimental; urgency=medium

  [ Francesco Paolo Lovergine ]
  * New upstream major release: build system moved to cmake.
  * Now following general advice from upstream about packaging as listed
    in http://gmt.soest.hawaii.edu/projects/gmt/wiki/PackagingGMT
  * Added a new cmake patch with Debian changes to CMake configurations.
  * Removed autotools b-dep and rules.
  * Removed all (obsolete) patches.
  * Moved to current full dh_* auto support.
  * Octave/mex stuff now lives in its own repository and should go into
    a separate source package. So, dropped octave-gmt ATM.
  * Updated list of b-d.
  * Set Vcs-* fields to canonical forms.

  [ Ross Gammon ]
  * Update watch file with sepwatch changes.

  [ Bas Couwenberg ]
  * New upstream release.
  * Add myself to Uploaders.
  * Update watchfile, changes:
    - Use passive FTP
    - Add common dversionmangle
  * Restructure control file with cme, changes:
    - Update Vcs-Browser URL to use cgit instead of gitweb
    - Bump Standards-Version to 3.9.6, no changes.
  * Add gbp.conf to use pristine-tar by default.
  * Update copyright file, changes:
    - Changed GMT license to LGPL-3+ only
    - Update copyright years, add additional copyright holders
    - Add license & copyright for differently licensed files (mostly BSD/MIT)
  * Repack upstream source using Files-Excluded in the copyright file.
  * Fix libgmt5 installation.
  * Disable use of non-free triangle source.
  * Fix bash-completion installation.
  * Strip RPATH from binary & libraries.
  * Also exclude prebuilt documentation and manpages from repacked source.
  * Build documentation in build-indep target.
  * Use packaged jquery.js & underscore.js instead of embedded sphinx copies.
  * Move /usr/share/gmt to architecture-independent gmt-common package.
  * Recompress the manpages to not use timestamped gzip.
  * Add patches for various typos.
  * Add symbols file for libgmt5.
  * Add debug package.
  * Use Breaks/Replaces instead of versioned Conflicts.
  * Add manpage for gmt-config.
  * Drop gmt-tutorial-pdf package, no longer included upstream.
  * Use libfftw3-dev instead of sfftw-dev.
  * Update dependencies for new gmt-dcw & gmt-gshhg data packages.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 20 Jun 2015 17:14:18 +0200
